SystemOrganization addCategory: #TinyTower!

Object subclass: #Bitizen
	instanceVariableNames: 'bitName foodAbility serviceAbility recreationAbility retailAbility creativeAbility homeFloor jobFloor dreamJobName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!Bitizen classSide methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 13:33'!
bitName: aByteString dreamJobName: aByteString2 food: aSmallInteger service: aSmallInteger4 recreation: aSmallInteger5 retail: aSmallInteger6 creative: aSmallInteger7 
	^self new
		bitName: aByteString;
		foodAbility: aSmallInteger;
		serviceAbility: aSmallInteger4;
		recreationAbility: aSmallInteger5;
		retailAbility: aSmallInteger6;
		creativeAbility: aSmallInteger7;
		dreamJobName: aByteString2! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
bitName
	^ bitName! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
bitName: aString
	bitName := aString
! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
creativeAbility
	^ creativeAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
creativeAbility: anInteger
	creativeAbility := anInteger! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 13:33'!
dreamJobName: aByteString 
	dreamJobName := aByteString ! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
foodAbility
	^ foodAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
foodAbility: anInteger
	foodAbility := anInteger! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
homeFloor
	^ homeFloor! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
homeFloor: aFloor
	homeFloor := aFloor
! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:22'!
job
	^ job! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:22'!
job: aString
	job := aString
! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
jobFloor
	^ jobFloor! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
jobFloor: aFloor
	jobFloor := aFloor
! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:05'!
listRowLiteral
	^{bitName. foodAbility printString. serviceAbility printString. recreationAbility printString. retailAbility printString. creativeAbility printString}! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
recreationAbility
	^ recreationAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
recreationAbility: anInteger
	recreationAbility := anInteger! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
retailAbility
	^ retailAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
retailAbility: anInteger
	retailAbility := anInteger! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
serviceAbility
	^ serviceAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
serviceAbility: anInteger
	serviceAbility := anInteger! !

Object subclass: #Floor
	instanceVariableNames: 'number bitizens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Floor subclass: #CommercialFloor
	instanceVariableNames: 'job'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!CommercialFloor classSide methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:21'!
number: aSmallInteger job: aJob 
	^self new
		number: aSmallInteger;
		job: aJob! !

!CommercialFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 17:49'!
hasJobNamed: aByteString 
	^job jobName = aByteString ! !

!CommercialFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 01:30'!
isCommercialFloor
	^true! !

!CommercialFloor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:32'!
job
	^ job! !

!CommercialFloor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:32'!
job: aString
	job := aString
! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:26'!
listRowLiteral
	^{number printString. job jobName}! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 01:14'!
maxPopulation
	^3! !

!Floor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:12'!
number
	^ number! !

!Floor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:12'!
number: anInteger
	number := anInteger
! !

Floor subclass: #ResidentFloor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ResidentFloor classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:15'!
number: aSmallInteger 
	^self new number: aSmallInteger! !

!ResidentFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 17:49'!
hasJobNamed: aByteString 
	^false! !

!ResidentFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 01:29'!
isCommercialFloor
	^false! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:25'!
listRowLiteral
	^{number printString}! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 01:14'!
maxPopulation
	^5! !

Object subclass: #Job
	instanceVariableNames: 'jobName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Job subclass: #CreativeJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!CreativeJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 13:13'!
color
	^'crimson'! !

Job subclass: #FoodJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!FoodJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 13:13'!
color
	^'green'! !

!Job class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:18'!
crimsonJobName: string2
	^CreativeJob new jobName: string2! !

!Job class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:19'!
cyanJobName: string2
	^ServiceJob new jobName: string2! !

!Job class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:18'!
greenJobName: string2
	^FoodJob new jobName: string2! !

!Job class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:18'!
ivoryJobName: string2
	^RecreationJob new jobName: string2! !

!Job class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 13:11'!
jobName: aString
	^self new jobName: aString! !

!Job class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:19'!
purpleJobName: string2
	^RetailJob new jobName: string2! !

!Job methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 13:08'!
jobName
	^ jobName! !

!Job methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 13:08'!
jobName: aString
	jobName := aString
! !

Job subclass: #RecreationJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!RecreationJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 13:13'!
color
	^'ivory'! !

Job subclass: #RetailJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!RetailJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 13:12'!
color
	^'purple'! !

Job subclass: #ServiceJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ServiceJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 13:14'!
color
	^'cyan'! !

Object subclass: #TinyTowerGame
	instanceVariableNames: 'floors bitizens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TinyTowerGame classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2013 16:06'!
workspace1
| tt |
tt := TinyTowerGame new.
tt openBitizenListMorph.
tt openCommercialFloorListMorph.
tt bitizenFromUser.! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 19:32'!
bitizenFromUser

	^bitizens at: (UIManager default chooseFrom: (bitizens collect: #bitName))
	! !

!TinyTowerGame methodsFor: 'list - bitizen' stamp: 'HwaJong 12/10/2012 13:52'!
bitizenList
	^bitizens! !

!TinyTowerGame methodsFor: 'list - bitizen' stamp: 'HwaJong 12/10/2012 13:55'!
bitizenListSelectionIndex
	^0! !

!TinyTowerGame methodsFor: 'list - bitizen' stamp: 'HwaJong 12/10/2012 13:55'!
bitizenListSelectionIndex: aSmallInteger 
	^self! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:19'!
bitizens
	^bitizens! !

!TinyTowerGame methodsFor: 'list - commerical floor' stamp: 'HwaJong 12/10/2012 19:10'!
commercialFloorList
	^floors select: [:each | each isCommercialFloor]! !

!TinyTowerGame methodsFor: 'list - commerical floor' stamp: 'HwaJong 12/10/2012 17:28'!
commericalFloorListSelectionIndex
	^0! !

!TinyTowerGame methodsFor: 'list - commerical floor' stamp: 'HwaJong 12/10/2012 18:01'!
commericalFloorListSelectionIndex: aSmallInteger 
	^self! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 12/10/2012 17:47'!
floorAt: aSmallInteger 
	^floors detect: [:each| each number = aSmallInteger]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 12/10/2012 17:48'!
floorJobNamed: aByteString 
	^floors detect: [:each| each hasJobNamed: aByteString] ! !

!TinyTowerGame methodsFor: 'initialize-release' stamp: 'HwaJong 12/10/2012 13:16'!
initialize 
	super initialize.
	self initializeFloors.
	self initializeBitizens.! !

!TinyTowerGame methodsFor: 'initialize-release' stamp: 'HwaJong 12/10/2012 19:22'!
initializeBitizens
	"self newBitizenName: '' dreamJobName: '' homeFoorNumber:  food:  service:  recreation:  retail:  creative:  employedAt: ''."
	bitizens :=
	{
		self newBitizenName: 'SHIRLEY BYRD' dreamJobName: 'ART STUDIO' homeFoorNumber: 5 food: 0 service: 3 recreation: 3 retail: 6 creative: 9 employedAt: 'PHOTO STUDIO'.
		self newBitizenName: 'PENNY GARCIA' dreamJobName: 'ROCK CLIMBING' homeFoorNumber: 8 food: 2 service: 4 recreation: 9 retail: 1 creative: 9 employedAt: 'PHOTO STUDIO'.		
		self newBitizenName: 'MAXINE COOPER' dreamJobName: 'SHIP & PRINT' homeFoorNumber: 2 food: 8 service: 9 recreation: 7 retail: 8 creative: 9 employedAt: 'PHOTO STUDIO'.
		self newBitizenName: 'ELAINE BAILEY' dreamJobName: 'HEALTH CLUB' homeFoorNumber: 2 food: 8 service: 9 recreation: 7 retail: 8 creative: 9 employedAt: 'HAT SHOP'.
		self newBitizenName: 'C. BENNETT' dreamJobName: 'GAME STUDIO' homeFoorNumber: 10 food: 2 service: 7 recreation: 5 retail: 0 creative: 8 employedAt: ''.
		self newBitizenName: 'DAWN PEARSON' dreamJobName: 'POTTERY STUDIO' homeFoorNumber: 5 food: 2 service: 4 recreation: 5 retail: 7 creative: 8 employedAt: 'HAT SHOP'.
	}! !

!TinyTowerGame methodsFor: 'initialize-release' stamp: 'HwaJong 12/10/2012 19:29'!
initializeFloors
	floors :=
	{
		ResidentFloor number: 2.
		CommercialFloor number: 3 job: (Job greenJobName: 'SUB SHOP').
		CommercialFloor number: 4 job: (Job purpleJobName: 'HAT SHOP').
		ResidentFloor number: 5.
		CommercialFloor number: 6 job: (Job ivoryJobName: 'VIDEO RENTAL').
		CommercialFloor number: 7 job: (Job crimsonJobName: 'PHOTO STUDIO').
		ResidentFloor number: 8.
		CommercialFloor number: 9 job: (Job ivoryJobName: 'PLANETARIUM').
		ResidentFloor number: 10.
	}.! !

!TinyTowerGame methodsFor: 'initialize-release' stamp: 'HwaJong 12/10/2012 19:28'!
newBitizenName: string1 dreamJobName: string2 homeFoorNumber: integer1 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6 employedAt: string3 
	| bitizen |
	bitizen := Bitizen bitName: string1 dreamJobName: string2 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6.
	bitizen homeFloor: (self floorAt: integer1).
	string3 = ''
		ifFalse: [bitizen jobFloor: (self floorJobNamed: string3)].
	^bitizen! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 19:34'!
openBitizenListMorph
|bl|
bl := PluggableMultiColumnListMorph on: self list: #bitizenList selected: #bitizenListSelectionIndex changeSelected: #bitizenListSelectionIndex: menu: nil wrapSelector: #listRowLiteral.
bl openInWindow.! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 19:35'!
openCommercialFloorListMorph
|fl|
fl := PluggableMultiColumnListMorph on: self list: #commercialFloorList selected: #commericalFloorListSelectionIndex changeSelected: #commericalFloorListSelectionIndex: menu: nil wrapSelector: #listRowLiteral.
fl openInWindow.! !
